<template>
  <InfoBox title="Marktübersicht">
    <template slot="header-action">
      <MarketDropdown @market-select="setActiveMarket" />
    </template>
    <div
      v-if="activeMarket"
      class="flex justify-between mb-2"
      :style="{ color: activeMarket.differenceInPercent < 0 ? '#C81818' : '#08AB1E' }"
    >
      <span>{{ activeMarket.totalValue }}</span>
      <span>{{ activeMarket.differenceInPercent > 0 ? '+' : '' }}{{ activeMarket.differenceInPercent }}%</span>
    </div>
    <client-only>
      <ApexChart
        type="area"
        :options="options"
        :series="series"
      />
    </client-only>
  </InfoBox>
</template>

<script lang="ts">
import Vue from 'vue';
import { mapState } from 'vuex';

export default Vue.extend({
  data () {
    return {
      activeMarketId: -1
    };
  },

  computed: {
    ...mapState({
      marketData: (state: any) => state.marketData
    }),

    activeMarket () {
      return this.marketData.find((market: any) => market.marketId === (this as any).activeMarketId);
    },

    options () {
      return {
        chart: {
          animations: {
            enabled: false
          },
          zoom: {
            enabled: true,
            autoScaleYaxis: true
          },
          toolbar: {
            show: false
          }
        },
        dataLabels: {
          enabled: false
        },
        fill: {
          type: 'gradient',
          gradient: {
            shadeIntensity: 1,
            inverseColors: false,
            opacityFrom: 0.5,
            opacityTo: 0,
            stops: [0, 90, 100]
          }
        },
        yaxis: {
          labels: {
            formatter: (val: number) => {
              return val.toFixed(0);
            }
          },
          title: {
            text: 'Punkte'
          }
        },
        xaxis: {
          type: 'datetime'
        },
        tooltip: {
          shared: false,
          y: {
            formatter: (val: number) => {
              return val.toFixed(0);
            }
          }
        }
      };
    },

    series () {
      // TODO this part must be fixed
      const data = [] as any[];

      let ts2 = 1484418600000;

      for (let i = 0; i < 40; i++) {
        ts2 = ts2 + 86400000;
        const innerArr = { x: ts2, y: Math.random() * (36000 - 28000) + 28000 };
        data.push(innerArr);
      }

      return [{
        name: ((this as any).activeMarket || {}).name || this.marketData[0].indexName,
        type: 'area',
        data
      }];
    }
  },

  methods: {
    setActiveMarket (marketId: number) {
      (this as any).activeMarketId = marketId;
    }
  }
});
</script>
